require 'sandthorn_driver_event_store'
require 'ap'
require 'uuidtools'
require 'in_memory_event_store_driver'

# This file was generated by the `rspec --init` command. Conventionally, all
# specs live under a `spec` directory, which RSpec adds to the `$LOAD_PATH`.
# Require this file using `require "spec_helper"` to ensure that it is only
# loaded once.
#
# See http://rubydoc.info/gems/rspec-core/RSpec/Core/Configuration
RSpec.configure do |config|
  config.run_all_when_everything_filtered = true
  config.filter_run :focus
  config.filter_run_excluding benchmark: true
  config.order = 'random'
end
def prepare_for_test context: :test
#  migrator.send(:clear_for_test)
end

def event_store_driver_memory
	SandthornDriverEventStore::InMemoryEventStoreDriver.new
end

def event_store_driver
	event_store.driver
end

def event_store
  @event_store ||= SandthornDriverEventStore.driver host: "db", port: 2113, page_size: 20
  return @event_store
end
